<id>
Akismet for YaBB 2.7.00
</id>

<version>
0.6
</version>

<mod info>
Description
-----------
This Mod will allow you to check forum posts on Akismet to prevent spam.

Installation
------------
1) Modify YaBB files using YaBMod.
2) Go to Admin Center - Anti-spam Settings - Akismet to enable the feature.


Version History
---------------
V0.1 - First release - 7th December 2012
V0.2 - updated for YaBB 2.6.0 by Dandello - July 17, 2014
V0.3 - updated for YaBB 2.6.1 by Dandello - Sept 02, 2014
V0.4 - updated for YaBB 2.6.11 by Dandello - Dec 12, 2014
V0.5 - updated for YaBB 2.7.00 by Dandello - Mar 1, 2016
V0.6 - updated for YaBB 2.7.00 strict by Dandello - Feb 26 2018
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://yabbforumsoftware.com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $akismet_mod = q~Akismet for YaBB|Derek Barnstorm (updated for 2.7.00 by Dandello)|This Mod will allow you to check forum posts on Akismet to prevent spam.|0.6|26th Feb 2018~;
    push @installed_mods, $akismet_mod;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Akismet for YaBB';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($akismet_enabled, $akismet_postcount, $akismet_api_key);
$akismet_enabled ||=0;
$akismet_postcount ||= 0;
$akismet_api_key ||= q{};
</add before>

<search for>
1;
EOF
</search for>

<add before>
\$akismet_enabled = $akismet_enabled;          # Set to 1 to check to check posts for spam with Akismet
\$akismet_postcount = $akismet_postcount;      # Set the amount of posts a member must have before their posts are no longer checked
\$akismet_api_key = "\Q$akismet_api_key\E";    # Akismet API Key

</add before>

<edit file>
Admin/Settings_Antispam.pm
</edit file>

<search for>
if (@settings_antispampmmods) {
</search for>

<add before>
push @settings_antispampmmods, 'Akismet for YaBB';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $akismet_enabled, $akismet_postcount, $akismet_api_key );
$akismet_api_key ||= q{};
</add before>

<search for>
my $bdomains = join "\n", @bdomains;
</search for>

<add after>

$akismet_postcount ||= 10;
</add after>

<search for>
                name     => 'bdomains',
                validate => 'fulltext,null',
            },
        ],
    },
</search for>

<add after>
    {
        name  => $settings_txt{'akismet'},
        id    => 'akismet',
        items => [
            {
                description =>
qq~<label for="akismet_enabled">$admin_txt{'akismet_enable'}</label>~,
                input_html =>
qq~<input type="checkbox" name="akismet_enabled" id="akismet_enabled" value="1"${ischecked($akismet_enabled)} />~,
                name     => 'akismet_enabled',
                validate => 'boolean',
            },
            {
                description =>
qq~<label for="akismet_postcount">$admin_txt{'akismet_postcount'}</label>~,
                input_html =>
qq~<input type="text" name="akismet_postcount" id="akismet_postcount" size="3" value="$akismet_postcount" />~,
                name       => 'akismet_postcount',
                validate   => 'number',
                depends_on => ['akismet_enabled'],
            },
            {
                description =>
qq~<label for="akismet_api_key">$admin_txt{'akismet_api_key'}</label>~,
                input_html =>
qq~<input type="text" name="akismet_api_key" id="akismet_api_key" size="35" value="$akismet_api_key" />~,
                name       => 'akismet_api_key',
                validate   => 'text,null',
                depends_on => ['akismet_enabled'],
            },
        ],
    },
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
if (@englishadminlngmods) {
</search for>

<add before>
push @englishadminlngmods, 'Akismet for YaBB';
</add before>

<search for>
1;
</search for>

<add before>
## Akismet Mod ##
$admin_txt{'akismet_enable'} = q~Check forum posts with Akismet?<br /><span class="small">Doesn't apply to Administrators, Global Moderators, Forum Moderators or Moderators.</span>~;
$admin_txt{'akismet_postcount'} = 'Minimum amount of posts a member must have before their posts are no longer checked:';
$admin_txt{'akismet_api_key'} = 'Your Akismet API Key:';
$settings_txt{'akismet'} = 'Akismet';

</add before>

<edit file>
Languages/English/Post.lng
</edit file>

<search for>
if (@englishpostlngmods) {
</search for>

<add before>
push @englishpostlngmods, 'Akismet for YaBB';
</add before>

<search for>
1;
</search for>

<add before>
$post_txt{'akismet_api_error'} = 'Sorry, there was an error posting your message. If the problem persists, please contact the Forum Administrator.';
$post_txt{'akismet_server_error'} = 'Sorry, there was an error posting your message. This is only a temporary connection error, so please either go back and try again or try again later.';
$post_txt{'akismet_spam_error'} = 'Action not allowed: Our system has detected that you are a spammer. If you think that this is an error, please contact the Forum Administrator.';

</add before>

<edit file>
Sources/Post.pm
</edit file>

<search for>
if (@postpmmods) {
</search for>

<add before>
push @postpmmods, 'Akismet for YaBB';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $akismet_enabled, $akismet_postcount, $akismet_api_key );
</add before>

<search for>
            if ($spamdetected) { fatal_error( 'tsc_alert', $spamword ); }
            else               { fatal_error('speed_alert'); }
        }
    }
</search for>

<add after>

    if (
           $akismet_enabled
        && $akismet_api_key
        && (
            $iamguest
            || ( ${ $uid . $username }{'postcount'} <= $akismet_postcount
                && !$staff )
        )
      )
    {
        use Net::Akismet;
        my $akismet_message = $message;
        $akismet_message =~ s/\[.*?\]//gsm;
        my $akismet_name = ($iamguest) ? $name : $username;
        my $akismet_email =
          ($iamguest) ? $email : ${ $uid . $username }{'email'};
        my $akismet_user_url = ${ $uid . $username }{'weburl'} || q{};
        my $akismet = Net::Akismet->new(
            KEY => $akismet_api_key,
            URL => $scripturl,
        ) || fatal_error( q{}, "$post_txt{'akismet_api_error'}" );

        my $verdict = $akismet->check(
            USER_IP              => $user_ip,
            COMMENT_USER_AGENT   => $ENV{'HTTP_USER_AGENT'},
            COMMENT_CONTENT      => $akismet_message,
            COMMENT_AUTHOR       => $akismet_name,
            COMMENT_AUTHOR_EMAIL => $akismet_email,
            COMMENT_AUTHOR_URL   => $akismet_user_url,
            REFERRER             => $ENV{'HTTP_REFERER'},
            COMMENT_TYPE         => 'forum-post',
        ) || fatal_error( q{}, "$post_txt{'akismet_server_error'}" );

        if ( 'true' eq $verdict ) {
            fatal_error( '', "$post_txt{'akismet_spam_error'}" );
        }
    }
</add after>
